// this code was generated using the rkwarddev package.
//perhaps don't make changes here, but in the rkwarddev script instead!

function preprocess(){
	// add requirements etc. here

}

function calculate(){
	// read in variables from dialog
	var vrslDtmtrxrd = getValue("vrsl_Dtmtrxrd");
	var chcRmvmssng = getValue("chc_Rmvmssng");
	var chcStdrdzvl = getValue("chc_Stdrdzvl");
	var drpCmpttnmt = getValue("drp_Cmpttnmt");
	var spnPwrfMnkw = getValue("spn_PwrfMnkw");
	var drpAgglmrtn = getValue("drp_Agglmrtn");
	var chcDrwdndrg = getValue("chc_Drwdndrg");
	var svbSvrsltst = getValue("svb_Svrsltst");
	var spnDrwbrdr1 = getValue("spn_Drwbrdr1");

	// the R code to be evaluated
	if(chcRmvmssng) {
		echo("\t# Listwise removal of missings\n\t" + vrslDtmtrxrd + " <- na.omit(" + vrslDtmtrxrd + ")\n");
	} else {}
	if(chcStdrdzvl) {
		echo("\t# Standardizing values\n\t" + vrslDtmtrxrd + " <- scale(" + vrslDtmtrxrd + ")\n");
	} else {}
	echo("\t# Compute distance matrix\n\tclust.h.distances <- dist(");
	if(vrslDtmtrxrd) {
		echo("\n\t\tx=" + vrslDtmtrxrd);
	} else {}
	echo(",\n\t\tmethod=\"" + drpCmpttnmt + "\"");
	if(drpCmpttnmt == "minkowski") {
		echo(",\n\t\tp=" + spnPwrfMnkw);
	} else {}
	echo("\n\t)\n");
	echo("\t# Hierarchical CA\n\tclust.h.result <- hclust(d=clust.h.distances");
	echo(",\n\t\tmethod=\"" + drpAgglmrtn + "\"");
	echo("\n\t)\n\n");
}

function printout(){
	// all the real work is moved to a custom defined function doPrintout() below
	// true in this case means: We want all the headers that should be printed in the output:
	doPrintout(true);
}

function preview(){
	preprocess();
	calculate();
	doPrintout(false);
}

function doPrintout(full){
	// read in variables from dialog
	var vrslDtmtrxrd = getValue("vrsl_Dtmtrxrd");
	var chcRmvmssng = getValue("chc_Rmvmssng");
	var chcStdrdzvl = getValue("chc_Stdrdzvl");
	var drpCmpttnmt = getValue("drp_Cmpttnmt");
	var spnPwrfMnkw = getValue("spn_PwrfMnkw");
	var drpAgglmrtn = getValue("drp_Agglmrtn");
	var chcDrwdndrg = getValue("chc_Drwdndrg");
	var svbSvrsltst = getValue("svb_Svrsltst");
	var spnDrwbrdr1 = getValue("spn_Drwbrdr1");

	// create the plot
	if(full) {
		echo("rk.header(\"Hierarchical CA results\", level=1)\n");
	} else {}

	if(chcDrwdndrg) {
		if(full) {
	echo("rk.graph.on()\n");
} else {}
echo("\ttry({\n\t\tplot(clust.h.result)");
if(spnDrwbrdr1 > 1) {
	echo("\n\t\trect.hclust(clust.h.result, k=" + spnDrwbrdr1 + ", border=\"red\")");
} else {}
echo("\n\t})\n");
if(full) {
	echo("rk.graph.off()\n");
} else {}
	} else {
		echo("\trk.print(clust.h.result)\n");
	}

	// left over from the printout function

	var svbSvrsltst = getValue("svb_Svrsltst");
	var svbSvrsltstActive = getValue("svb_Svrsltst.active");
	var svbSvrsltstParent = getValue("svb_Svrsltst.parent");
	if(svbSvrsltstActive) {
		echo("assign(\"" + svbSvrsltst + "\", clust.h.result, envir=" + svbSvrsltstParent + ")\n");
	} else {}


}