// this code was generated using the rkwarddev package.
//perhaps don't make changes here, but in the rkwarddev script instead!

function preprocess(){
	// add requirements etc. here

}

function calculate(){
	// read in variables from dialog
	var vrslDtmtrxrd = getValue("vrsl_Dtmtrxrd");
	var chcRmvmssng = getValue("chc_Rmvmssng");
	var chcStdrdzvl = getValue("chc_Stdrdzvl");
	var spnNmbrfcls = getValue("spn_Nmbrfcls");
	var drpAlgorthm = getValue("drp_Algorthm");
	var spnMxmmnmbr = getValue("spn_Mxmmnmbr");
	var spnIntlrndm = getValue("spn_Intlrndm");
	var chcPltrslts = getValue("chc_Pltrslts");
	var svbSvrsltst = getValue("svb_Svrsltst");
	var chcPltclstr = getValue("chc_Pltclstr");

	// the R code to be evaluated
	if(chcRmvmssng) {
		echo("\t# Listwise removal of missings\n\t" + vrslDtmtrxrd + " <- na.omit(" + vrslDtmtrxrd + ")\n");
	} else {}
	if(chcStdrdzvl) {
		echo("\t# Standardizing values\n\t" + vrslDtmtrxrd + " <- scale(" + vrslDtmtrxrd + ")\n");
	} else {}
	echo("\tclust.k.result <- kmeans(");
	if(vrslDtmtrxrd) {
		echo("\n\t\tx=" + vrslDtmtrxrd);
	} else {}
	echo(",\n\t\tcenters=" + spnNmbrfcls);
	if(drpAlgorthm != "Hartigan-Wong") {
		echo(",\n\t\talgorithm=\"" + drpAlgorthm + "\"");
	} else {}
	if(spnMxmmnmbr != 10) {
		echo(",\n\t\titer.max=" + spnMxmmnmbr);
	} else {}
	if(spnIntlrndm != 1) {
		echo(",\n\t\tnstart=" + spnIntlrndm);
	} else {}
	echo("\n\t)\n\n");
}

function printout(){
	// all the real work is moved to a custom defined function doPrintout() below
	// true in this case means: We want all the headers that should be printed in the output:
	doPrintout(true);
}

function preview(){
	preprocess();
	calculate();
	doPrintout(false);
}

function doPrintout(full){
	// read in variables from dialog
	var vrslDtmtrxrd = getValue("vrsl_Dtmtrxrd");
	var chcRmvmssng = getValue("chc_Rmvmssng");
	var chcStdrdzvl = getValue("chc_Stdrdzvl");
	var spnNmbrfcls = getValue("spn_Nmbrfcls");
	var drpAlgorthm = getValue("drp_Algorthm");
	var spnMxmmnmbr = getValue("spn_Mxmmnmbr");
	var spnIntlrndm = getValue("spn_Intlrndm");
	var chcPltrslts = getValue("chc_Pltrslts");
	var svbSvrsltst = getValue("svb_Svrsltst");
	var chcPltclstr = getValue("chc_Pltclstr");

	// create the plot
	if(full) {
		echo("rk.header(\"Cluster analysis\", level=1)\n");
	} else {}

	if(chcPltrslts) {
		if(full) {
	echo("rk.graph.on()\n");
} else {}
echo("\ttry({\n\t\tplot(" + vrslDtmtrxrd + ", col=clust.k.result$cluster, " + "main=\"K-means partitioning\", sub=\"Grouped into " + spnNmbrfcls + " clusters by the " + drpAlgorthm + " algorithm\")");
if(chcPltclstr) {
	echo("\n\t\tpoints(clust.k.result$centers, col=1:" + spnNmbrfcls + ", pch=8, cex=2)");
} else {}
echo("\n\t})\n");
if(full) {
	echo("rk.graph.off()\n");
} else {}
	} else {
		echo("\trk.print(clust.k.result)\n");
	}

	// left over from the printout function

	var svbSvrsltst = getValue("svb_Svrsltst");
	var svbSvrsltstActive = getValue("svb_Svrsltst.active");
	var svbSvrsltstParent = getValue("svb_Svrsltst.parent");
	if(svbSvrsltstActive) {
		echo("assign(\"" + svbSvrsltst + "\", clust.k.result, envir=" + svbSvrsltstParent + ")\n");
	} else {}


}